
ChiliProject - Bug # 422: cvs test are not working

Status: Closed Priority: Normal
Author: Gregor Schmidt Category: SCM
Created: 2011-05-20 Assignee: Felix Schäfer
Updated: 2011-05-21 Due date:
Remote issue URL:
Affected version: unstable
Description: The test for the CVS adapter in the current unstable are broken. The errors started to occur with the merge of 

@acts_as_journalized@ and are present in all configurations. 

This seems to be the significant part of the stack:

<pre>
wrong number of arguments (8 for 2) (ArgumentError)
gems/activerecord-2.3.11/lib/active_record/associations/association_proxy.rb:215:in `slice'
gems/activerecord-2.3.11/lib/active_record/associations/association_proxy.rb:215:in `send'
gems/activerecord-2.3.11/lib/active_record/associations/association_proxy.rb:215:in `method_missing'
gems/activerecord-2.3.11/lib/active_record/associations/association_collection.rb:394:in `method_missing'
vendor/plugins/acts_as_journalized/lib/redmine/acts/journalized/changes.rb:91:in 
`incremental_journal_changes'
vendor/plugins/acts_as_journalized/lib/redmine/acts/journalized/changes.rb:79:in `merge_journal_changes'
</pre>

See http://ci.chiliproject.org/job/chiliproject_unstable/32/testReport/ for more error details.

Associated revisions
2011-05-21 02:02 am - Felix SchÃ¤fer 
Replace a call to changes with its code from AR::Dirty. #422

acts_as_journalized called changes as per ActiveRecord::Dirty
(see http://ar.rubyonrails.org/classes/ActiveRecord/Dirty.html#M000291),
the journalized model Changeset :has_many changes though, which
made the call return a list of associated objects instead of the
intended list of changed attributes. Replaced changes with the code
from AR::Dirty to work around that.

History
2011-05-21 12:06 am - Felix Schäfer
Committed a fix in commit:6f809b826edf31b76c9e1743734aca6f975a8e42, the gist of the problem is described in the commit message, I'll copy it over 
here and close here once the CI confirms it works.

2011-05-21 05:29 am - Felix Schäfer
- Status changed from Open to Closed

Closing as the CVS tests pass on the CI too http://ci.chiliproject.org/job/chiliproject_unstable/40/testReport/.

The gist of the problem is: Changeset is a journalized model and :has_many changes, the problem is that this association creates a method 
@changes@ on @Changeset@ instances that overrides the method @changes@ provided by @ActiveRecord::Dirty@ that @acts_as_journalized@ 
relied on. I've changed the one occurrence of @changes@ in @acts_as_journalized@ by the exact definition of the method as per 
@ActiveRecord::Dirty@ to avoid the name clash.
